; GUI #
;torus.c - This program demonstrates the creation of a display list.
include win64a.inc
; --------------- 
Wwd equ 500
Wht equ 400
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC) shl 32 or \
	(sizeof WNDCLASSEX)
	push	rax                     ;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	Wht
	push	Wwd
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
        
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
        cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke  TranslateMessage,edi
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	rc:RECT

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
        cmp	edx,WM_CHAR
	je	wmCHAR
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
	invoke	RtlExitUserProcess,NULL
;-----------------------------------------
wmCHAR:	mov	al,r8b;wParam
	or	al,20h
	cmp	al,'x'
	jne	@f
	movd	xmm3,ebx
	movd	xmm2,ebx
	movd	xmm1,const1
	jmp	@0
@@:	cmp	al,'y'
	jne	@f
	movd	xmm3,ebx
	movd	xmm2,const1
	movd	xmm1,ebx
@0:	movd	xmm0,const3
        invoke  glRotatef
	jmp	@1
@@:	cmp	al,'i'
        jne	wmBYE
        invoke  glLoadIdentity
	movq	xmm3,rbx
	movq	xmm2,constd10
	movq	xmm1,rbx
	movq	xmm0,rbx
	invoke  gluLookAt,,,,,rbx,rbx,rbx,constd1,rbx
	invoke  glClear, GL_COLOR_BUFFER_BIT
	mov	eax,const1
	movd	xmm2,eax
	movd	xmm1,eax
	movd	xmm0,eax
	invoke  glColor3f
	mov	ecx,theTorus
	invoke  glCallList
	invoke  glFlush

@1:	lea	edx,rc
	invoke	GetClientRect,hWin
	lea	edx,rc
	invoke	InvalidateRect,hWin,,0
        jmp	wmBYE;PAINT
wmPAINT:; No pending messages: draw the scene
;Display the scene---------------
	lea	edx,ps
        invoke  BeginPaint,hWin
;GLDisplay---------------------------------------
        invoke  glClear, GL_COLOR_BUFFER_BIT ;or GL_DEPTH_BUFFER_BIT
	mov	eax,const1
	movd	xmm2,eax
	movd	xmm1,eax
	movd	xmm0,eax
	invoke  glColor3f
	mov	ecx,theTorus
	invoke  glCallList
	invoke  glFlush
;---------------------------------------
        invoke	SwapBuffers,hDC
	lea	edx,ps
	invoke  EndPaint,hWin
        jmp	wmBYE
wmSIZE:; --------------- Resize the scene
        movzx	ecx,r9w
	mov	edx,r9d
	shr	edx,16
	invoke	GLReshape
	xor	eax,eax
        jmp	wmBYE
wmCREATE:invoke	GetDC  ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   )
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax; 
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax;  
	invoke	wglCreateContext,hDC;     OpenGL
	mov	hrc,rax
	invoke	wglMakeCurrent,hDC,eax;   
;GLInit-----------------------------------------
	invoke  glGenLists,1
	mov     theTorus,eax
	invoke  glNewList,eax, GL_COMPILE
	invoke	torus,8,25
	invoke  glEndList

	invoke  glShadeModel, GL_FLAT
;------------------------------------------------	
	invoke	GLReshape,Wwd,Wht
wmBYE:	leave
	xor	eax,eax
	retn	
WndProc	endp
torus proc numc:dword, numt:dword
local	i:DWORD
local	j:DWORD
local	k:DWORD
local	x:QWORD
local	y:QWORD
local	s:QWORD
local	t:QWORD
local	fx:DWORD
local	fy:DWORD
local	fz:DWORD
local	temp:DWORD

	mov	numc,ecx
	mov	numt,edx

	fninit
	and	i, 0 ; i < numc; i++) {
@0:	invoke  glBegin, GL_QUAD_STRIP
	and     j, 0 ;j <= numt; j++) {
@1:	mov     k, 1 ; k >= 0; k--
@@:;s = (i + k) % numc + 0.5
	xor     edx,edx;edx = 0
	mov     eax, i
	add     eax, k
	div     numc
	mov     temp, edx ;remainder
	fild    temp
	fld    const0_5
	faddp
	fstp    s
;t = j % numt;
	xor     edx,edx
	mov     eax,j
	div     numt
	mov     temp,edx ;remainder
	fild    temp
	fstp    t
;x = (1+ .1 * cos(s * twopi/numc)) * cos(t * twopi/numt);
	fld     twopi
	fmul    s
	fidiv   numc
	fcos
	fld    const0_1
	fmulp
	fld1
	faddp
	fld     twopi
	fmul    t
	fidiv   numt
	fcos
	fmulp
	fstp    fx
;y = (1+.1*cos(s*twopi/numc))*sin(t*twopi/numt)
	fld     twopi
	fmul    s
	fidiv   numc
	fcos
	fld    const0_1
	fmulp
	fld1
	faddp
	fld     twopi
	fmul    t
	fidiv   numt
	fsin
	fmulp
	fstp    fy
;z = .1 * sin(s * twopi / numc);
	fld     s
	fmul    twopi
	fidiv   numc
	fsin
	fld    const0_1
	fmulp
	fstp    fz
	movd	xmm2,fz
	movd	xmm1,fy
	movd	xmm0,fx
	invoke  glVertex3f
	dec     k
	cmp k,0
	jge	@b
	inc     j
	mov     eax, numt
	cmp  j,eax
	jbe	@1
	invoke  glEnd
	inc     i
	mov     eax, numc
	cmp  i,eax
	jc	@0
	leave
	ret
torus endp

GLReshape proc	w:dword, h:dword
local resultq[2]:QWORD

	mov	w,ecx
	mov	h,edx

	fninit
	mov	r8d,ecx
	mov	r9d,edx
	invoke  glViewport,0,0
	invoke  glMatrixMode, GL_PROJECTION
	invoke  glLoadIdentity
	fild	w
	fidiv	h
	fstp    resultq
	movq	xmm3,constd100;Specifies the distance from the viewer to the 
;far clipping plane (always positive)
	movq	xmm2,constd1;Specifies the distance from the viewer to the 
;near clipping plane (always positive)
	movq	xmm1,resultq;Specifies the aspect ratio that determines the 
;field of view in the x direction. The aspect ratio is the ratio of x (width) 
;to y (height).
	movq	xmm0,constd30;Specifies the field of view angle, in degrees, 
;in the y direction
        invoke  gluPerspective;set up a perspective projection matrix
	invoke  glMatrixMode, GL_MODELVIEW
	invoke  glLoadIdentity
	movq	xmm3,rbx
	movq	xmm2,constd10
	movq	xmm1,rbx
	movq	xmm0,rbx
	invoke  gluLookAt,,,,,rbx,rbx,rbx,constd1,rbx
;1 eyex - The position of the eye point.
;2 eyey - The position of the eye point.
;3 eyez - The position of the eye point.
;4 centerx - The position of the reference point.
;5 centery - The position of the reference point.
;6 centerz - The position of the reference point.
;7 upx - The direction of the up vector.
;8 upy - The direction of the up vector.
;9 upz - The direction of the up vector.
	leave
	retn
GLReshape endp
hDC	dq	?
hrc	dq	?
theTorus	dd 0
twopi 	dq 6.283185307179586477

PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR;  
  	nVersion          dw	1;  
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or \
	PFD_DRAW_TO_WINDOW ;  ,     
  	iPixelType        db	PFD_TYPE_RGBA; RGBA 
  	cColorBits        db	32;   
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;  
  	cAlphaBits        db	0;  
  	cAlphaShift       db	0;  
  	cAccumBits        db	0;  
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;  
  	cDepthBits        db	32;32  Z- ( )
  	cStencilBits      db	0;  
  	cAuxBuffers       db	0;  
  	iLayerType        db	PFD_MAIN_PLANE;  
  	bReserved         db	0;
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;  

szClassName	db "OpenGL - Display List: Torus",0
FileName	db "br_Rabbit3.cur",0
const0_1	dd 0.1
const0_5	dd 0.5
const1		dd 1.0
const3		dd 3.0
constd1		dq 1.0
constd10	dq 10.0
constd30	dq 30.0
constd100	dq 100.0
end